unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.REST, WEBLib.Grids, Vcl.Grids,
  WEBLib.DBCtrls, Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls, WEBLib.SideMenu,
  WEBLib.WebCtrls, WEBLib.ExtCtrls, Data.DB, WEBLib.CDS, WEBLib.DB;

type
  TForm1 = class(TWebForm)
    WebClientConnection1: TWebClientConnection;
    WebClientDataSet1: TWebClientDataSet;
    WebClientDataSet1id: TStringField;
    WebClientDataSet1email: TStringField;
    WebClientDataSet1organisation_id: TIntegerField;
    WebClientDataSet1is_active: TIntegerField;
    WebClientDataSet1is_suspended: TIntegerField;
    WebClientDataSet1suspended_at: TStringField;
    WebClientDataSet1created_at: TStringField;
    WebClientDataSet1updated_at: TStringField;
    WebHttpRequest1: TWebHttpRequest;
    WebPanel1: TWebPanel;
    editSearch: TWebEdit;
    WebHTMLDiv1: TWebHTMLDiv;
    WebSideMenu1: TWebSideMenu;
    wpMessages: TWebPanel;
    WebDBGrid1: TWebDBGrid;
    wpSearch: TWebPanel;
    lbSearch: TWebLabel;
    WebLabel11: TWebLabel;
    WebLabel12: TWebLabel;
    WebDataSource1: TWebDataSource;
    WebClientDataSet1service_provider_user_id: TStringField;
    WebClientDataSet1client_user_id: TStringField;
    WebClientDataSet1client_name: TStringField;
    WebClientDataSet1client_surname: TStringField;
    WebClientDataSet1client_website: TStringField;
    WebClientDataSet1client_telephone_number: TStringField;
    WebClientDataSet1client_notes: TStringField;
    WebClientDataSet1xero_account_id: TStringField;
    WebClientDataSet1client_email: TStringField;
    WebClientDataSet1client_org_id: TIntegerField;
    WebClientDataSet1client_org_name: TStringField;
    WebClientDataSet1logo_url: TStringField;
    WebClientDataSet1invoice_prefix: TStringField;
    WebClientDataSet1vat_number: TStringField;
    WebClientDataSet1registration_number: TStringField;
    WebClientDataSet1ioss_number: TStringField;
    WebClientDataSet1eori_number: TStringField;
    WebClientDataSet1org_email: TStringField;
    WebClientDataSet1phone: TStringField;
    WebClientDataSet1website: TStringField;
    WebClientDataSet1shopify_url: TStringField;
    WebClientDataSet1ebay_url: TStringField;
    WebClientDataSet1amazon_url: TStringField;
    WebClientDataSet1tradepeg_url: TStringField;
    WebClientDataSet1shopify_user_name: TStringField;
    WebClientDataSet1ebay_user_name: TStringField;
    WebClientDataSet1amazon_user_name: TStringField;
    WebClientDataSet1tradepeg_user_name: TStringField;
    WebClientDataSet1org_status: TStringField;
    WebClientDataSet1relationship_status: TStringField;
    WebClientDataSet1client_since: TStringField;
    WebClientDataSet1royal_mail_api_key: TStringField;
    WebClientDataSet1royal_mail_account_id: TStringField;
    WebClientDataSet1royal_mail_min_orders: TIntegerField;
    WebLabel1: TWebLabel;
    WebLabel2: TWebLabel;
    WebLabel3: TWebLabel;
    WebLabel4: TWebLabel;
    WebLabel5: TWebLabel;
    WebResponsiveGridPanel1: TWebResponsiveGridPanel;
    WebPanel2: TWebPanel;
    WebPanel3: TWebPanel;
    WebButton1: TWebButton;
    WebButton2: TWebButton;
    WebPanel4: TWebPanel;
    WebButton3: TWebButton;
    wpFavorites: TWebPanel;
    WebLabel10: TWebLabel;
    WebLabel13: TWebLabel;
    WebLabel14: TWebLabel;
    WebPanel5: TWebPanel;
    WebLabel6: TWebLabel;
    WebLabel7: TWebLabel;
    WebEdit1: TWebEdit;
    WebEdit2: TWebEdit;
    WebMemo1: TWebMemo;
    WebPanel6: TWebPanel;
    WebResponsiveGridPanel2: TWebResponsiveGridPanel;
    WebPanel7: TWebPanel;
    WebButton4: TWebButton;
    WebPanel8: TWebPanel;
    WebButton5: TWebButton;
    WebPanel9: TWebPanel;
    WebButton6: TWebButton;
    WebPanel10: TWebPanel;
    WebButton7: TWebButton;
    WebPanel11: TWebPanel;
    WebButton8: TWebButton;
    procedure editSearchKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpdateVerticalDisplay;
    procedure WebSideMenu1ItemClick(Sender: TObject; AIndex: Integer);
    procedure WebClientConnection1AfterConnect(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
    procedure WebHTMLDiv1Click(Sender: TObject);
    procedure CardClick(const AClientUserId: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.editSearchKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  SearchText: string;
begin
  SearchText := EditSearch.Text;

  // Apply filter to dataset
  if SearchText = '' then
    WebClientDataSet1.Filtered := False  // Clear filter if search is empty
  else
  begin
    WebClientDataSet1.Filter :=
      Format('(client_user_id LIKE ''%%%s%%'') OR ' +
             '(client_name LIKE ''%%%s%%'') OR ' +
             '(client_surname LIKE ''%%%s%%'') OR ' +
             '(client_email LIKE ''%%%s%%'') OR ' +
             '(client_telephone_number LIKE ''%%%s%%'') OR ' +
             '(client_org_name LIKE ''%%%s%%'')',
      [SearchText, SearchText, SearchText, SearchText, SearchText, SearchText]);
    WebClientDataSet1.Filtered := True;
  end;

  // Update the display
  UpdateVerticalDisplay;
end;





procedure TForm1.UpdateVerticalDisplay;
var
  HTML: string;
begin
  if not WebClientDataSet1.Active then Exit;

  HTML := '<div style="padding: 10px;">';

  WebClientDataSet1.DisableControls;
  try
    WebClientDataSet1.First;
    while not WebClientDataSet1.Eof do
    begin
      HTML := HTML +
        Format('<div onclick="return window.pas.Unit1.Form1.CardClick(''%s'')" style="cursor: pointer; margin-bottom: 20px; padding: 10px; border: 1px solid #eee; border-radius: 4px; background-color: white;">' +
        // Organization ID (Bold)
        '<div style="margin-bottom: 8px;">' +
        '<div style="font-size: 16px; font-weight: bold;">%s</div>' +
        '</div>' +

        // Name and Surname
        '<div style="margin-bottom: 8px;">' +
        '<div style="color: #666;">%s %s</div>' +
        '</div>' +

        // Email
        '<div style="margin-bottom: 8px;">' +
        '<div style="color: #666;">%s</div>' +
        '</div>' +

        // Phone Number
        '<div style="margin-bottom: 8px;">' +
        '<div style="color: #666;">%s</div>' +
        '</div>' +
        '</div>',
        [
          WebClientDataSet1.FieldByName('client_user_id').AsString,
          WebClientDataSet1.FieldByName('client_org_name').AsString,
          WebClientDataSet1.FieldByName('client_name').AsString,
          WebClientDataSet1.FieldByName('client_surname').AsString,
          WebClientDataSet1.FieldByName('client_email').AsString,
          WebClientDataSet1.FieldByName('client_telephone_number').AsString
        ]);

      WebClientDataSet1.Next;
    end;
  finally
    WebClientDataSet1.EnableControls;
  end;

  HTML := HTML + '</div>';
  WebHTMLDiv1.HTML.Text := HTML;
end;
procedure TForm1.WebButton1Click(Sender: TObject);
const
  SECRET_TOKEN = 'Bearer auth1'; // Use the same token you set in n8n
begin
  WebClientConnection1.Active := false;
  WebClientConnection1.URI := 'http://localhost:5678/webhook/mysql';
  WebClientConnection1.Headers.Values['Authorization'] := SECRET_TOKEN;
  //WebClientConnection1.DataSet := WebClientDataSet1;
  //WebClientConnection1.ResponseJSON := True;
  WebClientConnection1.Active := True;
end;

procedure TForm1.WebClientConnection1AfterConnect(Sender: TObject);
begin
       UpdateVerticalDisplay;
end;

// ... existing code ...

procedure TForm1.WebHTMLDiv1Click(Sender: TObject);
var
  ClickedElement: TJSHTMLElement;
  ParentCard: TJSHTMLElement;
  IdElement: TJSHTMLElement;
  ClickedId: string;
begin
  // Get the clicked element
  ClickedElement := TJSHTMLElement(document.activeElement);

  // Find the parent card div
  ParentCard := ClickedElement;
  while (ParentCard <> nil) and (ParentCard.getAttribute('data-card') <> 'true') do
  begin
    ParentCard := TJSHTMLElement(ParentCard.parentElement);
  end;

  if ParentCard <> nil then
  begin
    // Find the ID element using data attribute
    IdElement := TJSHTMLElement(ParentCard.querySelector('[data-field="id"]'));
    if IdElement <> nil then
    begin
      ClickedId := IdElement.innerText;

      // Locate the record in the dataset
      if WebClientDataSet1.Locate('client_user_id', ClickedId, []) then
      begin
       // ShowMessage('Organization ID: '  WebClientDataSet1.FieldByName('client_org_id').AsString);
      end;
    end;
  end;
end;

// ... existing code ...
procedure TForm1.WebSideMenu1ItemClick(Sender: TObject; AIndex: Integer);
const
  SECRET_TOKEN = 'Bearer auth1'; // Use the same token you set in n8n

begin
  case AIndex of
    1:
      begin
//        lbMessages.Caption := 'Messages';
      //  WebHTTPRequest1.Headers.Values['Authorization'] := SECRET_TOKEN;
      //  WebHttpRequest1.URL := 'http://localhost:5678/webhook/mysql';
      //  WebHttpRequest1.Execute();


  WebClientConnection1.URI := 'http://localhost:5678/webhook/mysql';
  WebClientConnection1.Headers.Values['Authorization'] := SECRET_TOKEN;
  //WebClientConnection1.DataSet := WebClientDataSet1;
  //WebClientConnection1.ResponseJSON := True;
  WebClientConnection1.Active := True;
      end;
    2: //lbMessages.Caption := 'Messages: News';
  //  3: lbMessages.Caption := 'Messages: Inbox';


  end;

end;

procedure TForm1.CardClick(const AClientUserId: string);
begin
  if WebClientDataSet1.Locate('client_user_id', AClientUserId, []) then
  begin
   // ShowMessage('Organization ID: '       WebClientDataSet1.FieldByName('client_org_id').AsString);
  end;
end;

end.